{% extends 'en/en_base.html' %}
{% load static %}
{% load poll_extras %}

{% block content %}
<section>
    <div class="spacer">
        <h3 class="mb-5">
            Observations
        </h3>
        <div class="d-grid gap-2 d-md-flex justify-content-md-end mt-3">
            <button type="button" class="btn btn-primary btn-block" data-bs-toggle="modal"
                data-bs-target="#filterModal">
                <i class="bi bi-filter"></i> Filter
            </button>
            <div class="modal fade" id="filterModal" tabindex="-1" aria-labelledby="filterModalLabel"
                aria-hidden="true">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="filterModalLabel">
                                Filter
                            </h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
                            </button>
                        </div>
                        <div class="modal-body">
                            <form id="filter" class="row g-3">
                                <div class="col-md-12 col-lg-6">
                                    <label for="date" class="form-label">Date Added</label>
                                    <select name="date" class="form-select">
                                        <option value="ASC" {% if filter_date == 'ASC' %} selected {% endif %}>
                                            Ascending
                                        </option>
                                        <option value="DESC" {% if filter_date == 'DESC' %} selected {% endif %}>
                                            Descending
                                        </option>
                                    </select>
                                </div>
                                <div class="col-md-12 col-lg-6">
                                    <label for="" class="form-label">Category</label>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="category" value="shark" 
                                        {% if 'shark' in filter_categories %} checked {% endif %}>
                                        <label class="form-check-label" for="category">
                                            Shark
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="category" value="ray" 
                                        {% if 'ray' in filter_categories %} checked {% endif %}>
                                        <label class="form-check-label" for="category">
                                            Ray & Skates
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="category" value="chimaera"
                                            {% if 'chimaera' in filter_categories %} checked {% endif %}>
                                        <label class="form-check-label" for="category">
                                            Chimaera
                                        </label>
                                    </div>
                                </div>
                                <div class="col-auto me-auto"></div>
                                <div class="col-auto">
                                    <button type="submit" class="btn btn-success">
                                        Apply
                                    </button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row row-cols-1 row-cols-md-3 g-4 py-3">
            {% for observation, observation_image in paginator_object %}
            <a href="{% url 'frontend:contributor_observation' observation.pk %}" class="no-link">
                <div class="col">
                    <div class="card h-100">
                        {% if observation_image %}
                        <img src="{{ observation_image.image.url }}" class="card-img-top">
                        {% else %}
                        <img src="{% static 'images/common/no-image.jpeg' %}" class="card-img-top">
                        {% endif %}
                        <div class="card-body c-blue">
                            {% if observation.status == 'PENDING' %}
                            <span class="badge rounded-pill bg-warning mb-3">{{ observation.status }}</span>
                            {% elif observation.status == 'REJECTED' %}
                            <span class="badge rounded-pill bg-danger mb-3">{{ observation.status }}</span>
                            {% else %}
                            <span class="badge rounded-pill bg-success mb-3">{{ observation.status }}</span>
                            {% endif %}
                            <h5 class="card-title">{{ observation.common_name|default:"Unidentified" }}</h5>
                            <p class="card-text">
                                <span class="c-lightblue">
                                    <i>({{ observation.scientific_name|default:"Unidentified" }})</i>
                                </span>
                            </p>
                        </div>
                    </div>
                </div>
            </a>
            {% endfor %}
        </div>
        {% if paginator_object.has_other_pages %}
        <nav aria-label="pagination">
            <ul class="pagination justify-content-center mt-5">
                {% if paginator_object.has_previous %}
                <li class="page-item">
                    <a class="page-link"
                        href="{{ request.get_full_path|unique_query_page }}&page={{ paginator_object.previous_page_number }}">
                        &laquo;
                    </a>
                </li>
                {% else %}
                <li class="page-item disabled">
                    <span class="page-link">&laquo;</span>
                </li>
                {% endif %}
                {% for p in page_range|default_if_none:paginator_object.paginator.get_elided_page_range %}
                {% if paginator_object.number == p %}
                <li class="page-item active">
                    <span class="page-link">{{ p }}</span>
                </li>
                {% else %}
                <li class="page-item">
                    <a href="{{ request.get_full_path|unique_query_page }}&page={{ p }}" class="page-link">
                        {{ p }}
                    </a>
                </li>
                {% endif %}
                {% endfor %}
                {% if paginator_object.has_next %}
                <li class="page-item">
                    <a href="{{ request.get_full_path|unique_query_page }}&page={{ paginator_object.next_page_number }}"
                        class="page-link">
                        &raquo;
                    </a>
                </li>
                {% else %}
                <li class="page-item disabled">
                    <span class="page-link">&raquo;</span>
                </li>
                {% endif %}
            </ul>
        </nav>
        {% endif %}
    </div>
</section>
{% endblock %}

{% block js %}
<script>
    $(document).ready(function () {
        var filterForm = $("#filter");
        filterForm.on("submit", function (event) {
            event.preventDefault();
            var queryParams = filterParameters(filterForm.serialize());
            if (queryParams == undefined) {
                toastr.error("Select min 1 category")
                return;
            }

            window.location = `/contributor/observations?${queryParams}`
        });

        function filterParameters(parametersString) {
            // Split the parameters string into an array of key-value pairs
            const paramsArray = parametersString.split('&');

            // Initialize variables to store filtered parameters
            let filteredParams = [];
            let categoryParams = [];
            let categoryCount = 0;

            // Iterate through the parameters array
            paramsArray.forEach(param => {
                const [key, value] = param.split('=');
                if (key === 'date' && value.toUpperCase() === 'DESC') {
                    filteredParams.push(param);
                } else if (key === 'category') {
                    categoryParams.push(param);
                    categoryCount++;
                }
            });

            if (categoryCount === 0) {
                return undefined;
            }

            if (categoryCount <= 2) {
                filteredParams = filteredParams.concat(categoryParams)
            }

            return filteredParams.join('&')
        }
    });
</script>
{% endblock %}